// Program 3-13
// NOTE: The Java language does not allow pass by reference.
// Consequently, this is not an equivalent version of Program 3-12
// in the textbook.
//
// This program shows functions named getGrossPay and getBonuses
// that may be alternatively demonstrated, at the instructor's discretion.
// The textbook covers functions in Chapter 6.

import java.util.Scanner;

public class Program3_13
{
   // The following declares a constant that is globally visible.
   // The constant represents the rate of contribution.
   public final static double CONTRIBUTION_RATE = 0.05;
   
   public static void main(String[] args)
   {
      // Local variables
      double annualGrossPay;
      double totalBonuses;
      
      // Get the annual gross pay.
      annualGrossPay = getGrossPay();
      
      // Get the total of the bonuses.
      totalBonuses = getBonuses();
      
      // Display the contribution for
      // the gross pay.
      showGrossPayContrib(annualGrossPay);
      
      // Display the contribution for
      // the bonuses.
      showBonusContrib(totalBonuses);
   }
   
   // The getGrossPay module gets the
   // gross pay and returns it.
   public static double getGrossPay()
   {
      Scanner keyboard = new Scanner(System.in);
      double grossPay;
      System.out.print("Enter the total gross pay: ");
      grossPay = keyboard.nextDouble();
      return grossPay;
   }
   
   // The getBonuses module gets the
   // amount of bonuses and returns it.
   public static double getBonuses()
   {
      Scanner keyboard = new Scanner(System.in);
      double bonuses;
      System.out.print("Enter the amount of bonuses: ");
      bonuses = keyboard.nextDouble();
      return bonuses;
   }
   
   // The showGrossPayContrib module
   // accepts the gross pay as an argument
   // and displays the retirement contribution
   // for gross pay.
   public static void showGrossPayContrib(double grossPay)
   {
      double contrib;
      contrib = grossPay * CONTRIBUTION_RATE;
      System.out.println("The contribution for the gross pay");
      System.out.println("is $" + contrib);
   }
   
   // The showBonusContrib module accepts
   // the bonus amount as an argument and
   // displays the retirement contribution
   // for bonuses.
   public static void showBonusContrib(double bonuses)
   {
      double contrib;
      contrib = bonuses * CONTRIBUTION_RATE;
      System.out.println("The contribution for the bonuses");
      System.out.println("is $" + contrib);
   }
}