//   Program 9-2
import java.util.Scanner;

public class Program9_2
{
   public static void main(String[] args)
   {
      final int SIZE = 6;                 // Array size
      int[] testScores = new int[SIZE];   // Array to hold test scores
      
      // Get the test scores.
      getTestScores(testScores);
   
      // Sort the test scores.
      bubbleSort(testScores);
   
      // Display the test scores.
      System.out.println("Here are the test scores");
      System.out.println("sorted from lowest to highest.");
      showTestScores(testScores);
   }
   
   // The getTestScores method prompts the user
   // to enter test scores into the array that is
   // passed as an argument.
   public static void getTestScores(int[] array)
   {
      // Counter variable
      int index;
      
      // Create a Scanner object to read keyboard input.
      Scanner keyboard = new Scanner(System.in);
      
      // Get the test scores.
      for (index = 0; index < array.length; index++)
      {
         System.out.print("Enter score number " +(index + 1) + ": ");
        array[index] =  keyboard.nextInt();
      }
   }
   
   /**
      The bubbleSort method uses the bubble sort algorithm
      to sort an int array.
      Note the following:
      (1) We do not have to pass the array size because in
          Java arrays have a length field.
      (2) We do not have a separate method to swap values.
          This is because Java does not allow pass by
          reference. The swap is perfomed inside this method.
   */
   
   public static void bubbleSort(int[] array)
   {
      int maxElement;  // Marks the last element to compare
      int index;       // Index of an element to compare
      int temp;        // Used to swap to elements
      
      // The outer loop positions maxElement at the last element
      // to compare during each pass through the array. Initially
      // maxElement is the index of the last element in the array.
      // During each iteration, it is decreased by one.
      for (maxElement = array.length - 1; maxElement >= 0; maxElement--)
      {
         // The inner loop steps through the array, comparing
         // each element with its neighbor. All of the elements
         // from index 0 thrugh maxElement are involved in the
         // comparison. If two elements are out of order, they
         // are swapped.
         for (index = 0; index <= maxElement - 1; index++)
         {
            // Compare an element with its neighbor.
            if (array[index] > array[index + 1])
            {
               // Swap the two elements.
               temp = array[index];
               array[index] = array[index + 1];
               array[index + 1] = temp;
            }
         }
      }
   }
   
   // The showTestScores module displays the contents
   // of the array that is passed as an argument.
   public static void showTestScores(int[] array)
   {
      // Counter variable
      int index;
      
      // Display the test scores.
       for (index = 0; index < array.length; index++)
       {
         System.out.println(array[index]);
       }
   }

}