// Program 9-4
public class Program9_4
{
   public static void main(String[] args)
   {
      // Constant for the array size
      final int SIZE = 6;
      
      // An array of strings
      String[] names = { "David", "Abe", "Megan",
                         "Beth", "Jeff", "Daisy" };
      
      // Loop counter
      int index;
      
      // Display the array in its original order.
      System.out.println("Original order:");
      for (index = 0; index < names.length; index++)
      {
         System.out.println(names[index]);
      }
      
      // Sort the names.
      bubbleSort(names);
      
      // Display a blank line.
      System.out.println();
   
      // Display the sorted array.
      System.out.println("Sorted order:");
      for (index = 0; index < names.length; index++)
      {
         System.out.println(names[index]);
      }
   }
   
   // The following bubbleSort method sorts
   // an array of Strings.
   
   public static void bubbleSort(String[] array)
   {
      int maxElement;  // Marks the last element to compare
      int index;       // Index of an element to compare
      String temp;     // Used to swap two elements
      
      // The outer loop positions maxElement at the last element
      // to compare during each pass through the array. Initially
      // maxElement is the index of the last element in the array.
      // During each iteration, it is decreased by one.
      for (maxElement = array.length - 1; maxElement >= 0; maxElement--)
      {
         // The inner loop steps through the array, comparing
         // each element with its neighbor. All of the elements
         // from index 0 thrugh maxElement are involved in the
         // comparison. If two elements are out of order, they
         // are swapped.
         for (index = 0; index <= maxElement - 1; index++)
         {
            // Compare an element with its neighbor.
            if (array[index].compareTo(array[index + 1]) < 0)
            {
               // Swap the two elements.
               temp = array[index];
               array[index] = array[index + 1];
               array[index + 1] = temp;
            }
         }
      }
   }
}