// Program 9-5

public class Program9_5
{
   public static void main(String[] args)
   {
      // Create an int array with test values.
      int[] numbers = { 4, 6, 1, 3, 5, 2 };

      // Loop counter
      int index;
      
      // Display the array in its original order.
      System.out.println("Original order: ");
      for (index = 0; index < numbers.length; index++)
         System.out.println(numbers[index]);
      
      // Sort the array.
      selectionSort(numbers);

      // Display a blank line.
      System.out.println();

      // Display the sorted array.
      System.out.println("Sorted order: ");
      for (index = 0; index < numbers.length; index++)
         System.out.println(numbers[index]);
   }

   //   The selectionSort method performs a selection sort on an
   //   int array. The array is sorted in ascending order.

   public static void selectionSort(int[] array)
   {
      int startScan;   // Starting position of the scan
      int index;       // To hold a subscript value
      int minIndex;    // Element with smallest value in the scan
      int minValue;    // The smallest value found in the scan

      // The outer loop iterates once for each element in the
      // array. The startScan variable marks the position where
      // the scan should begin.
      for (startScan = 0; startScan < (array.length-1); startScan++)
      {
         // Assume the first element in the scannable area
         // is the smallest value.
         minIndex = startScan;
         minValue = array[startScan];
         
         // Scan the array, starting at the 2nd element in
         // the scannable area. We are looking for the smallest
         // value in the scannable area. 
         for(index = startScan + 1; index < array.length; index++)
         {
            if (array[index] < minValue)
            {
               minValue = array[index];
               minIndex = index;
            }
         }

         // Swap the element with the smallest value 
         // with the first element in the scannable area.
         array[minIndex] = array[startScan];
         array[startScan] = minValue;
      }
   }
}