// Program 9-6

public class Program9_6
{
   public static void main(String[] args)
   {
      // Create an int array with test values.
      int[] numbers = { 4, 6, 1, 3, 5, 2 };

      // Loop counter
      int index;
      
      // Display the array in its original order.
      System.out.println("Original order: ");
      for (index = 0; index < numbers.length; index++)
         System.out.println(numbers[index]);
      
      // Sort the array.
      insertionSort(numbers);

      // Display a blank line.
      System.out.println();

      // Display the sorted array.
      System.out.println("Sorted order: ");
      for (index = 0; index < numbers.length; index++)
         System.out.println(numbers[index]);
   }

   // The insertionSort method performs an insertion sort on
   // an int array. The array is sorted in ascending order.

   public static void insertionSort(int[] array)
   {
      int unsortedValue;  // The first unsorted value
      int scan;           // Used to scan the array
      
      // The outer loop steps the index variable through 
      // each subscript in the array, starting at 1. This
      // is because element 0 is considered already sorted.
      for (int index = 1; index < array.length; index++)
      {
         // The first element outside the sorted subset is
         // array[index]. Store the value of this element
         // in unsortedValue.
         unsortedValue = array[index];
         
         // Start scan at the subscript of the first element
         // outside the sorted subset.
         scan = index;
         
         // Move the first element outside the sorted subset
         // into its proper position within the sorted subset.
         while (scan > 0 && array[scan-1] > unsortedValue)
         {
            array[scan] = array[scan - 1];
            scan--;
         }
         
         // Insert the unsorted value in its proper position
         // within the sorted subset.
         array[scan] = unsortedValue;
      }
   }
}