// Program 9-7

import java.util.Scanner;

public class Program9_7
{
   public static void main(String[] args)
   {
      // Array of instructor names, already sorted in
      // ascending order
      String[] names = { "Hall", "Harrison",
                         "Hoyle", "Kimura",
                         "Lopez", "Pike" };
   
      // Parallel array of instructor phone numbers
      String[] phones = { "555-6783", "555-0199",
                           "555-9974", "555-2377",
                           "555-7772", "555-1716" };
                           
      // Variable to hold the name to search for
      String searchName;
      
      // Variable to hold subscript of the name.
      int index;
      
      // Variable to control the loop
       String again = "Y";
       
       // Create a Scanner object to read keyboard input.
       Scanner keyboard = new Scanner(System.in);
       
      while (again.equalsIgnoreCase("Y"))
      {
         // Get the name to search for.
         System.out.print("Enter a name to search for: ");
         searchName = keyboard.nextLine();
         
         // Search for the name.
         index = binarySearch(names, searchName);
         
         if (index != -1)
         {
            // Display the phone number.
            System.out.println("The phone number is " + phones[index]);
         }
         else
         {
            // The name was not found in the array.
            System.out.println(searchName + " was not found.");
         }
         
         // Search again?
         System.out.print("Do you want to search again? (Y=Yes) ");
         again = keyboard.nextLine();
      }
   }
   
   //   The binarySearch method performs a binary search on a
   //   String array. The array is searched for the string passed
   //   to value. If the string is found, its array subscript
   //   is returned. Otherwise, -1 is returned indicating the
   //   value was not found in the array.

   public static int binarySearch(String[] array, String value)
   {
      int first;       // First array element
      int last;        // Last array element
      int middle;      // Mid point of search
      int position;    // Position of search value
      boolean found;   // Flag

      // Set the inital values.
      first = 0;
      last = array.length - 1;
      position = -1;
      found = false;

      // Search for the value.
      while (!found && first <= last)
      {
         // Calculate mid point
         middle = (first + last) / 2;
         
         // If value is found at midpoint...
         if (array[middle].equals(value))
         {
            found = true;
            position = middle;
         }
         // else if value is in lower half...
         else if (array[middle].compareTo(value) > 0)
            last = middle - 1;
         // else if value is in upper half....
         else
            first = middle + 1;
      }

      // Return the position of the item, or -1
      // if it was not found.
      return position;
   }
}