// Program 10-14

import java.io.*;
import java.util.Scanner;

public class Program10_14
{
   public static void main(String[] args) throws IOException
   {
      // Print the report header.
      printHeader();
      
      // Print the details of the report.
      printDetails();
   }

   // The printHeader method prints the report header.
   public static void printHeader()
   {
      System.out.println("Pinebrook Academy Fundraiser Report\n");
      System.out.println("Student ID       Donation Amount");
      System.out.println("======================================");
   }

   // The printDetails module prints the report details.
   public static void printDetails() throws IOException
   {
      // Variables for the fields
      int studentID;
      double donation;
      
      // Accumulator variables
      double studentTotal = 0;
      double total = 0;
      
      // Flag for the first record.
      boolean firstRecord = true;
      
      // Variable to use in the control
      // break logic
      int currentID = 0;
      
      // Declare an input file and open it.
      Scanner donationsFile = new Scanner(new File("donations.dat"));
      
      // NOTE: The logic to read all the records from the file
      // and print subtotals is slightly different from the 
      // pseudocode in the book because the Scanner object looks 
      // ahead to see if another item can be read from the file.
      
      // Print the report details.
      while (donationsFile.hasNext())
      {
         // Read a record
         studentID = donationsFile.nextInt();
         donation = donationsFile.nextDouble();
         
         // Check to see if this is the first record.
         if (firstRecord)
         {
            currentID = studentID;
            firstRecord = false;
         }
         
         // Check the student ID field to see if
         // it has changed.
         if (studentID != currentID)
         {
            // Print the total for the student,
            // followed by a blank line.
            System.out.printf("Total donations for student: $%,.2f\n\n",
                               studentTotal);
            
            // Save the next student's ID number.
            currentID = studentID;
            
            // Reset the student accumulator.
            studentTotal = 0;
         }
         
         // Print the data for the donation.
         System.out.printf("%d               $%,.2f\n", studentID, donation);
         
         // Update the accumulators.
         studentTotal = studentTotal + donation;
         total = total + donation;
         
      } // end while
      
      // Print the total for the last student,
      // followed by a blank line.
      System.out.printf("Total donations for student: $%,.2f\n\n",
                         studentTotal);
         
      // Print the total of all donations.
      System.out.printf("Total of all donations: $%,.2f\n", total);
      
      // Close the file.
      donationsFile.close();
   }
}