import java.util.Scanner;

public class Program12_5
{
   public static void main(String[] args)
   {
      // Create a Scanner object for keyboard input.
      Scanner keyboard = new Scanner(System.in);
      
      // Constant for the minmum password length
      final int MIN_LENGTH = 8;
          
      // Local variable to hold the user's password
      String password;
      
      // Display some information about the program.
      System.out.println("This program determines whether a password");
      System.out.println("meets the following requirements:");
      System.out.println("(1) It must be at least 8 characters long.");
      System.out.println("(2) It must contain at least one uppercase letter.");
      System.out.println("(3) It must contain at least one lowercase letter.");
      System.out.println("(4) It must contain at least one numeric digit.");
      System.out.println();
      
      // Get a password from the user.
      System.out.print("Enter a password.");
      password = keyboard.nextLine();
    
      // Validate the password.
      if (password.length() >= MIN_LENGTH && 
          numberUpperCase(password) >= 1 &&
          numberLowerCase(password) >= 1 && 
          numberDigits(password) >= 1)
      {
          System.out.println("The password is valid.");
      }
      else
      {
         System.out.println("The password does not meet the requirements.");
      }
   }
   
   // The numberUpperCase method accepts a string
   // argument and returns the number of uppercase
   // letters it contains.
   public static int numberUpperCase(String str)
   {
      // Variable to hold the number of uppercase letters
      int count = 0;
      
      // Variable to use stepping through str
      int index;
      
      // Step through str counting the number
      // of uppercase letters.
      for (index = 0; index <= str.length() - 1; index++)
      {
          if (Character.isUpperCase(str.charAt(index)))
          {
             count = count + 1;
          }
      }
      
      // Return the number of uppercase letters.
      return count;
   }

   // The numberLowerCase method accepts a string
   // argument and returns the number of lowercase
   // letters it contains.
   public static int numberLowerCase(String str)
   {
      // Variable to hold the number of lowercase letters
      int count = 0;
      
      // Variable to use stepping through str
      int index;
      
      // Step through str counting the number
      // of lowercase letters.
      for (index = 0; index <= str.length() - 1; index++)
      {
          if (Character.isLowerCase(str.charAt(index)))
          {
             count = count + 1;
          }
      }
      
      // Return the number of lowercase letters.
      return count;
   }

   // The numberDigits method accepts a string
   // argument and returns the number of numeric
   // digits it contains.
   public static int numberDigits(String str)
   {
      // Variable to hold the number of digits
      int count = 0;
      
      // Variable to use stepping through str
      int index;
      
      // Step through str counting the number
      // of digits.
      for (index = 0; index <= str.length() - 1; index++)
      {
          if (Character.isDigit(str.charAt(index)))
          {
             count = count + 1;
          }
      }
      
      // Return the number of digits.
      return count;
   }
}
