import java.util.Scanner;

public class Program12_6
{
   public static void main(String[] args)
   {
      // Create a Scanner object for keyboard input.
      Scanner keyboard = new Scanner(System.in);
      
      // Declare a variable to hold a telephone number
      String phoneNumber;
      
      // Prompt the user to enter a telephone number.
      System.out.println("Enter a telephone number. The number you");
      System.out.println("enter should be formatted as (XXX)XXX-XXXX.");
      phoneNumber = keyboard.nextLine();
    
      // If the input is properly formatted, unformat it.
      if (isValidFormat(phoneNumber))
      {
			System.out.println("The unformatted number is " + unformat(phoneNumber));
      }
      else
      {
         System.out.println("That number is not properly formated.");
      }
   }
   
	// The isValidFormat method accepts a string argument
	// and determines whether it is properly formatted as
	// a US telephone number in the following manner:
	// (XXX)XXX-XXXX
	// If the argument is properly formatted, the method
	// returns True, otherwise False.
   public static Boolean isValidFormat(String str)
	{
      // Local variable to indicate valid format
      Boolean valid;
   
      // Determine whether str is properly formatted.
      if (str.length() == 13 && str.charAt(0) == '(' &&
          str.charAt(4) == ')' && str.charAt(8) == '-')
		{
         valid = true;
		}
      else
		{
         valid = false;
      }
      
      // Return the value of valid.
      return valid;
   }

	// The unformat method accepts a string
	// assumed to contain a telephone number formatted in
	// (XXX)XXX-XXXX
	// The method unformats the string by removing the
	// parentheses and the hyphen, and returns the unformatted
	// string.
	public static String unformat(String str)
	{
      // Store str in a StringBuilder object.
      StringBuilder strb = new StringBuilder(str);
		
		// First, delete the left paren at position 0.
		strb.delete(0, 1);
		
      // Next, delete the right paren. Because of the
      // previous deletion it is now located at
      // position 3.
      strb.delete(3, 4);
      
      // Next, delete the hyphen. Because of the
      // previous deletions it is now located at
      // position 6.
      strb.delete(6, 7);
		
		// Return the contents of the StringBuilder
		// as a string.
		return strb.toString();
	}
}
