import java.util.Scanner;

// Program 13-7

public class Program13_7
{
   public static void main(String [] args)
   {
      // Declare an array of employee ID numbers.
      int numbers[] = {101, 142, 147, 189, 199, 207, 222,
                       234, 289, 296, 310, 319, 388, 394,
                       417, 429, 447, 521, 536, 600};
      
      // Declare a variable to hold an ID number.
      int empID;
      
      // Declare a variable to hold the search results.
      int results;

      // Create a Scanner object for keyboard input.
      Scanner keyboard = new Scanner(System.in);

      // Get an employee ID number to search for.
      System.out.print("Enter an employee ID number: ");
      empID = keyboard.nextInt();

      // Search for the ID numbe in the array.
      results = binarySearch(numbers, 0, (numbers.length - 1), empID);

      // Display the results.
      if (results == -1)
      {
         System.out.println("That employee ID number was not found.");
      }
      else
      {
         System.out.println("That employee ID number was found at " +
                            "subscript " + results);
      }
   }

   // The binarySearch function performs a recursive binary search
   // on a range of elements in an Integer array. The parameter
   // array holds the array to be searched. The parameter first
   // holds the subscript of the range's starting element, and the
   // parameter last holds the subscript of the range's last element.
   // The parameter value holds the search value. If the search value
   // is found, its array subscript is returned. Otherwise, -1 is
   // returned indicating the value is not in the array.
   public static int binarySearch(int[] array, int first, int last, int value)
   {
      int middle;     // Mid point of search
        
      // Test for the base case where the
      // value is not found.
      if (first > last)
         return -1;
        
      // Calculate the middle position.
      middle = (first + last) / 2;
       
      // Search for the value.
      if (array[middle] == value)
         return middle;
      else if (array[middle] < value)
         return binarySearch(array, middle + 1,
                             last, value);
      else
         return binarySearch(array, first,
                             middle - 1, value);
   }
}