import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class TestAverage extends JFrame
{
   // Declare the components.
   private JLabel test1Label;
   private JLabel test2Label;
   private JLabel test3Label;
   private JLabel resultLabel;
   private JLabel averageLabel;
   
   private JTextField test1TextField;
   private JTextField test2TextField;
   private JTextField test3TextField;
   
   private JButton calcButton;
   private JButton exitButton;
   
   private JPanel panel1;
   private JPanel panel2;
   private JPanel panel3;
   private JPanel panel4;
   private JPanel panel5;
   
   // Constructor
   public TestAverage()
   {
      // Display a caption in the title bar.
      setTitle("Test Average");
      
      // Specify what happens when the close button is clicked.
      setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
      
      // Create the labels components.
      test1Label = new JLabel("Enter the score for test 1:");
      test2Label = new JLabel("Enter the score for test 2:");
      test3Label = new JLabel("Enter the score for test 3:");
      resultLabel = new JLabel("Average");
      averageLabel = new JLabel("");
      
      // Create the text field components. (In Java, a text box is
      // called a text field.)
      test1TextField = new JTextField(10);
      test2TextField = new JTextField(10);
      test3TextField = new JTextField(10);
      
      // Create the button components.
      calcButton = new JButton("Calculate Average");
      exitButton = new JButton("Exit");
      
      // Register action listeners for the buttons.
      calcButton.addActionListener(new CalcButtonListener());
      exitButton.addActionListener(new ExitButtonListener());
      
      // Create five panels to arrange the components.
      panel1 = new JPanel();
      panel2 = new JPanel();
      panel3 = new JPanel();
      panel4 = new JPanel();
      panel5 = new JPanel();
      
      // Add the desired componets to panel1.
      panel1.add(test1Label);
      panel1.add(test1TextField);
      
      // Add the desired components to panel2.
      panel2.add(test2Label);
      panel2.add(test2TextField);

      // Add the desired components to panel3.
      panel3.add(test3Label);
      panel3.add(test3TextField);
      
      // Add the desired components to panel4.
      panel4.add(resultLabel);
      panel4.add(averageLabel);

      // Add the desired components to panel5.
      panel5.add(calcButton);
      panel5.add(exitButton);
      
      setLayout(new GridLayout(5, 1));
      
      // Now, add all of the panels to the window's content pane.
      add(panel1);
      add(panel2);
      add(panel3);
      add(panel4);
      add(panel5);
      
      // Make the window visible.
      pack();
      setVisible(true);
   }
   
   public class CalcButtonListener implements ActionListener
   {
      // This method will execute when the calcButton is clicked.
      public void actionPerformed(ActionEvent e)
      {
         // Declare local variables to hold the test
         // scores and the average.
         double test1, test2, test3, average;
         
         // Get the first test score.
         test1 = Double.parseDouble(test1TextField.getText());
         
         // Get the second test score.
         test2 = Double.parseDouble(test2TextField.getText());

         // Get the third test score.
         test3 = Double.parseDouble(test3TextField.getText());
         
         // Calculate the average test score.
         average = (test1 + test2 + test3) / 3;
         
         // Display the average test score in the averageLabel
         // component.
         averageLabel.setText(Double.toString(average));
      }
   }

   public class ExitButtonListener implements ActionListener
   {
      // This method will execute when the exitButton is clicked.
      public void actionPerformed(ActionEvent e)
      {
         // End the application.
         System.exit(0);
      }
   }
   
   // The main method starts the program.
   public static void main(String[] args)
   {
      // Create an instance of the TestAverage class.
      new TestAverage();
   }
}